#include "bsp.h"
#include "tty.h"

/* Port mappings:

   P0	D0-D7
   P1	D8-D15

   P2	A0-A7
   P3	A8-A15
   P4	A16-A23

   P5	I/O Signals

*/

#define nWRL	p5.b0
#define nWRH	p5.b1
#define nRD	p5.b2
#define BCLK	p5.b3
#define HLDA	p5.b4
#define HOLD	p5.b5
#define ALE	p5.b6
#define	RDY	p5.b7

#define nWR	0x03;

#define F_IO_0	p9.b0
#define F_IO_1	p9.b1
#define F_IO_2	p9.b2
#define F_IO_3	p9.b3

extern void dllexit();

static void
set_addr (long a)
{
  p2.b = a;
  p3.b = a >> 8;
  p4.b = a >> 16;
}

static word
get_data (void)
{
  return p0.b | (p1.b << 8);
}

static void
put_data (word d)
{
  p0.b = d;
  p1.b = d >> 8;
}

static void
write_byte (long a, word d)
{
  pd0.b = pd1.b = 0xff;
  put_data (d);
  set_addr (a);
  p5.b &= ~nWR;
  while (!RDY && !tty_ready())
    asm("");
  p5.b |= nWR;
}

static word
read_byte (long a)
{
  word d;
  pd0.b = pd1.b = 0x00;
  set_addr (a);
  nRD = 0;
  while (!RDY && !tty_ready())
    asm("");
  d = get_data ();
  nRD = 1;
}

main()
{
  unsigned int i, j, t;
  unsigned char new_pd9;
  long addr = 0;

  p10.b = 0x33;

  F_IO_0 = 1; /* This is RESET */
  F_IO_1 = 1; /* chip select */

  /* P0 through P3 pullups */
  //pur0.b = 0xff;
  pur0.b = 0x00;
  /* P4 through P5 pullups */
  pur1.b = 0x00;

  pd0.b = 0x00;
  pd1.b = 0x00;

  pd2.b = 0xff;
  pd3.b = 0xff;
  pd4.b = 0xff;

  pd5.b = 0x5f; /* HLD, RDY are input */

  prcr.prc0 = 1;
  cm0 = 0x02; /* f8 = 2.5 MHz */

  new_pd9 = pd9.b | 0x0f;
  prcr.b = 0x04;
  pd9.b = new_pd9; /* f_io_8 */

  p2.b = p3.b = p4.b = 0;
  p5.b = 0xff;

#if 0
  cprintf("about to start...\n");
  while (!tty_ready ())
    ;
  tty_readc ();
#endif
  cprintf("running...\n");

  F_IO_0 = 0; /* reset */
  F_IO_1 = 0; /* chip select */
  p2.b = 0xff;

  i = 0;
  while (!tty_ready ())
    {
      write_byte (addr, i);
      BCLK = 0;
      read_byte (addr);
      addr ++;
      BCLK = 1;
      i++;
    }

  p2.b = p3.b = p4.b = p5.b = 0;
  p10.b = 0x00;
}
