.include	"m32c-87.inc"

	.macro	led val,b
	mov.b	#\val*64+\b*32, p10
	.endm

	.text
	.global	_spi_read_block
_spi_read_block:
	enter	#0
	;; 7[fp]:	byte *ptr
	;; 11[fp]:	int len
	led	0,1

1:	btst	$ti,u4c1
	jz	1b
	led	1,0
	mov.b	#0xff, u4tb	; one byte in flight

	mov.w	11[fb],r2
	mov.l	7[fb],a0
	add.w	#-1, r2

1:	btst	$ti,u4c1
	jz	1b
	
	add.l	#-1, a0

	;; Once we send the next byte out, we risk overruns if we get
	;; interrupted while two incoming bytes are in flight.  A
	;; sector transfer takes about 1mS anyway, so we just disable
	;; interrupts for the loop, which almost gives us continuous
	;; streaming.
	fclr	I
top:
	led	2, 1
	mov.b	#0xff, u4tb	; two bytes in flight
	add.l	#1, a0

	;; This is counter-intuitive, but adding just the right delay
	;; here means that the loop now takes exactly 32 cycles, the
	;; same as the SPI transfer time, so we never end up missing
	;; an SPI clock due to mis-timed checks in the btst/jz loop.
	nop
	nop
	nop

1:	btst	$ri,u4c1
	jz	1b
	mov.b	u4rb, [a0]	; one byte in flight
	led	1, 0

	;; If we needed to have interrupts serviced during the loop,
	;; this would be the place to do it.  In our case, this
	;; guarantees missing SPI cycles and taking more time.

	add.w	#-1,r2
	jnz	top

	add.l	#1,a0
1:	btst	$ri,u4c1
	jz	1b
	mov.b	u4rb, [a0]	; no bytes in flight
	led	0, 0

	fset	I

	exitd
